=== debian/changelog ===
seqan3 (3.3.0~rc.1+ds-3) unstable; urgency=medium

  * Release 3.3.0 RC1 to unstable with GCC 13 fixes. Closes: #1041371

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Jul 2023 12:49:27 +0200

seqan3 (3.3.0~rc.1+ds-2) experimental; urgency=medium

  * d/rules: nope, doc tests aren't ready yet.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 18 Jul 2023 12:23:25 +0200

seqan3 (3.3.0~rc.1+ds-1) experimental; urgency=medium

  * d/copyright: update excludes (range-v3 no longer used; doxygen-
    awecome added)
  * New upstream version
  * d/patches: refresh; dropped 2 applied upstream
  * d/rules: do the doc tests again

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 17 Jul 2023 19:04:40 +0200

seqan3 (3.2.0+ds-7) unstable; urgency=medium

  * Adopt debian/patches/better_gtest_benchmark_finding from upstream
  * debian/watch: grab the complete sources.
  * Refresh patch from upstream to cope with newer GCC 12 & 13.
    Closes: #1039561
  * Standards-Version: 4.6.2 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 11 Jul 2023 18:45:42 +0200
