=== debian/control ===
Source: seqan3
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               ninja-build,
               zlib1g-dev <!nocheck>,
               libbz2-dev <!nocheck>,
               libboost-dev <!nocheck>,
               libgtest-dev <!nocheck>,
               libcereal-dev <!nocheck>,
               libbenchmark-dev <!nocheck>,
               liblemon-dev <!nocheck>,
               doxygen <!nodoc>,
               graphviz <!nodoc>,
               cppreference-doc-en-html <!nodoc>,
               texlive-latex-base <!nodoc>,
               ghostscript <!nodoc>,
               texlive-latex-extra <!nodoc>,
               doxygen-awesome-css <!nodoc>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/seqan3
Vcs-Git: https://salsa.debian.org/med-team/seqan3.git
Homepage: https://www.seqan.de/
Rules-Requires-Root: no

Package: libseqan3-dev
Architecture: all
Section: libdevel
Depends: ${misc:Depends},
         zlib1g-dev,
         libbz2-dev,
         libcereal-dev
Description: C++ library for the analysis of biological sequences v3 (development)
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance.
 .
 This package contains the developer files.

Package: seqan3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}, doxygen-awesome-css
Suggests: libseqan3-dev
Description: C++ library for the analysis of biological sequences v3 (documentation)
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance.
 .
 This package contains the documentation and examples
