=== test/unit/alphabet/nucleotide/CMakeLists.txt ===
seqan3_test (dna4_test.cpp)
seqan3_test (dna5_test.cpp)
seqan3_test (dna15_test.cpp)
seqan3_test (dna16sam_test.cpp)
seqan3_test (dna3bs_test.cpp)
seqan3_test (rna4_test.cpp)
seqan3_test (rna5_test.cpp)
seqan3_test (rna15_test.cpp)
seqan3_test (nucleotide_conversion_integration_test.cpp)
seqan3_test (simd_dna4_test.cpp)
