=== debian/changelog ===
seqan3 (3.3.0~rc.2+ds-1) unstable; urgency=medium

  * New upstream version
  * d/patches: drop debian_cppreference and set
    SEQAN3_DOXYGEN_STD_TAGFILE instead, thanks to upstream adapting
    their buildsystem.
  * d/patches: remove better_gtest_benchmark_finding; upstream does a
    better job of accepting a system install of gtest & benchmark.
  * d/control: set the -doc package to not be apart of the the nodoc
    build profile

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 10 Aug 2023 10:09:07 +0200
