=== test/performance/alphabet/CMakeLists.txt ===
add_subdirectories ()

seqan3_benchmark (alphabet_assign_char_benchmark.cpp)
seqan3_benchmark (alphabet_assign_rank_benchmark.cpp)
seqan3_benchmark (alphabet_complement_benchmark.cpp)
seqan3_benchmark (alphabet_to_char_benchmark.cpp)
seqan3_benchmark (alphabet_to_rank_benchmark.cpp)
