=== test/unit/core/CMakeLists.txt ===
add_subdirectories ()

seqan3_test (add_enum_bitwise_operators_test.cpp)
seqan3_test (debug_stream_test.cpp)
