=== test/unit/test/CMakeLists.txt ===
seqan3_test (expect_range_eq_test.cpp)
seqan3_test (expect_same_type_test.cpp)
seqan3_test (file_access_test.cpp)
seqan3_test (pretty_printing_test.cpp)
seqan3_test (sandboxed_path_test.cpp)
seqan3_test (seqan2_test.cpp)
seqan3_test (sequence_generator_test.cpp)
seqan3_test (tmp_directory_test.cpp)
