=== test/performance/utility/bloom_filter/CMakeLists.txt ===
seqan3_benchmark (bloom_filter_benchmark.cpp)
