=== test/unit/alignment/aligned_sequence/CMakeLists.txt ===
seqan3_test (debug_stream_alignment_test.cpp)
