=== test/unit/alignment/cigar_conversion/CMakeLists.txt ===
seqan3_test (alignment_from_cigar_test.cpp)
seqan3_test (cigar_from_alignment_test.cpp)
