=== debian/changelog ===
seqan3 (3.3.0+ds-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 04 Sep 2023 18:14:20 +0200
